package com.loafle.overflow.models;

import javax.persistence.*;
import java.sql.Timestamp;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "TBL_PROBE", schema = "public", catalog = "postgres")
public class TblProbe {
    private long id;
    private String status;
    private String description;
    private Timestamp createDate;
    private Timestamp lastPollingDate;
    private Timestamp nextPollingDate;
    private long domainId;
    private String probeKey;
    private String encryptionKey;

    @Id
    @Column(name = "ID", nullable = false)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "STATUS", nullable = true, length = -1)
    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Basic
    @Column(name = "DESCRIPTION", nullable = true, length = 50)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Basic
    @Column(name = "CREATE_DATE", nullable = false)
    public Timestamp getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Timestamp createDate) {
        this.createDate = createDate;
    }

    @Basic
    @Column(name = "LAST_POLLING_DATE", nullable = true)
    public Timestamp getLastPollingDate() {
        return lastPollingDate;
    }

    public void setLastPollingDate(Timestamp lastPollingDate) {
        this.lastPollingDate = lastPollingDate;
    }

    @Basic
    @Column(name = "NEXT_POLLING_DATE", nullable = true)
    public Timestamp getNextPollingDate() {
        return nextPollingDate;
    }

    public void setNextPollingDate(Timestamp nextPollingDate) {
        this.nextPollingDate = nextPollingDate;
    }

    @Basic
    @Column(name = "DOMAIN_ID", nullable = false)
    public long getDomainId() {
        return domainId;
    }

    public void setDomainId(long domainId) {
        this.domainId = domainId;
    }

    @Basic
    @Column(name = "PROBE_KEY", nullable = false, length = 50)
    public String getProbeKey() {
        return probeKey;
    }

    public void setProbeKey(String probeKey) {
        this.probeKey = probeKey;
    }

    @Basic
    @Column(name = "ENCRYPTION_KEY", nullable = false, length = 50)
    public String getEncryptionKey() {
        return encryptionKey;
    }

    public void setEncryptionKey(String encryptionKey) {
        this.encryptionKey = encryptionKey;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TblProbe tblProbe = (TblProbe) o;

        if (id != tblProbe.id) return false;
        if (domainId != tblProbe.domainId) return false;
        if (status != null ? !status.equals(tblProbe.status) : tblProbe.status != null) return false;
        if (description != null ? !description.equals(tblProbe.description) : tblProbe.description != null)
            return false;
        if (createDate != null ? !createDate.equals(tblProbe.createDate) : tblProbe.createDate != null) return false;
        if (lastPollingDate != null ? !lastPollingDate.equals(tblProbe.lastPollingDate) : tblProbe.lastPollingDate != null)
            return false;
        if (nextPollingDate != null ? !nextPollingDate.equals(tblProbe.nextPollingDate) : tblProbe.nextPollingDate != null)
            return false;
        if (probeKey != null ? !probeKey.equals(tblProbe.probeKey) : tblProbe.probeKey != null) return false;
        if (encryptionKey != null ? !encryptionKey.equals(tblProbe.encryptionKey) : tblProbe.encryptionKey != null)
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = (int) (id ^ (id >>> 32));
        result = 31 * result + (status != null ? status.hashCode() : 0);
        result = 31 * result + (description != null ? description.hashCode() : 0);
        result = 31 * result + (createDate != null ? createDate.hashCode() : 0);
        result = 31 * result + (lastPollingDate != null ? lastPollingDate.hashCode() : 0);
        result = 31 * result + (nextPollingDate != null ? nextPollingDate.hashCode() : 0);
        result = 31 * result + (int) (domainId ^ (domainId >>> 32));
        result = 31 * result + (probeKey != null ? probeKey.hashCode() : 0);
        result = 31 * result + (encryptionKey != null ? encryptionKey.hashCode() : 0);
        return result;
    }
}
